/* append1.cpp times inserting 1 value at the end of an n-element list
 *   against inserting 1 values at the end of an n-element vector.
 *
 *  Author: Joel Adams, for Hands On C++.
 *  Date: November 1997.
 */

#include "Timer.h"                                   // Timer class
#include <vector>                                    // vector<>
#include <list>                                      // list<>
using namespace std;

// sets the number of times the test should be run
const int ITERATIONS = 1000;

double listTest (int n);
double vectorTest (int n);

int main()
{
  cout << "\nAppending 1 value to n-element containers.\n"
       << " Enter the starting size: ";
  int n;
  cin >> n;
  cout << "Running test..." << endl;
  double listTimePerOp = listTest(n);
  double vectorTimePerOp = vectorTest(n);
  cout << "result append1 " << n << " list " << listTimePerOp << endl;
  cout << "result append1 " << n << " vector " << vectorTimePerOp << endl;
}

double listTest (int n)
{
  Timer theTimer;
  theTimer.start();
  for (int iter = 1; iter <= ITERATIONS; iter++)
    {
      list<int> theList(n);
      theList.push_back(1);
    }
  theTimer.stop();
  return theTimer.seconds() / ITERATIONS;
}

double vectorTest (int n)
{
  Timer theTimer;
  theTimer.start();
  for (int iter = 1; iter <= ITERATIONS; iter++)
    {
      vector<int> theVector(n);
      theVector.push_back(1);
    }
  theTimer.stop();
  return theTimer.seconds() / ITERATIONS;
}
